﻿--[[

	Slam!Alert by Malivil: ---------
		Based off "Overpower Alert" code
		copyright 2005 by Interceptor
		Inspired by "Combat Sentry Gizmo" code
	V 0.06

]]--

------------------------------------------------------------------

-- // Register slash commands // --

function SA_SlashCommand(msg)
	SlamAlertOptions:Hide();
	if ( msg == "help" or msg == "" ) then
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SLASHCOMMAND);
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SLASHCOMMAND2);
	elseif ( msg == "on" ) then
		SA.on = 1;			
		SA.soundon = 1;			
		SA.messageon = 1;			
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SA_ON);
	elseif ( msg == "off" ) then
		SA.on = 0;			
		SA.soundon = 0;			
		SA.messageon = 0;			
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SA_OFF);
	elseif ( msg == "toggle" ) then
		if ( not SA.on or SA.on == 0 ) then
			SA.on = 1;			
			SA.soundon = 1;			
			SA.messageon = 1;			
			DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SA_ON);
		else
			SA.on = 0;			
			SA.soundon = 0;			
			SA.messageon = 0;			
			DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SA_OFF);
		end
	elseif ( msg == "status" ) then
		SA_Status();
	elseif ( (msg == "messageon") or (msg == "mon") ) then
		SA.messageon = 1;		
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_MESSAGE_ON);
	elseif ( (msg == "messageoff") or (msg == "moff") ) then
		SA.messageon = 0;		
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_MESSAGE_OFF);
	elseif ( (msg == "soundon") or (msg == "son") ) then
		SA.soundon = 1;		
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SOUND_ON);
	elseif ( (msg == "soundoff") or (msg == "soff") ) then
		SA.soundon = 0;
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SOUND_OFF);
	elseif ( (msg == "options") or (msg == "option") ) then
		SlamAlertOptions:Show();
	else		
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SLASHCOMMAND);
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SLASHCOMMAND2);
	end
end

function SA_OnLoad()
	-- Register events
	this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	this:RegisterEvent("VARIABLES_LOADED");

	SLASH_SA1 = "/SlamAlert";
	SLASH_SA2 = "/SA"

	SlashCmdList["SA"] = SA_SlashCommand;
end

function SA_OnEvent(self, event, ...)
	if( event == "VARIABLES_LOADED" ) then
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_WELCOME);
		if (not SA) then
			SA = {};
		end
		if (not SA.on) then
			SA.on = 1;	
		end	
		if (not SA.messageon) then
			SA.messageon = 1;
		end		
		if (not SA.soundon) then
			SA.soundon = 1;
		end
	end
	
	if (not SA.on or SA.on == 0) then
		return;
	end

	if( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		local _, type, _, sourceName, _, _, _, _ = select(1, ...);
		local playerName,_ = UnitName("player");
		if( playerName ~= sourceName ) then
			return;
		end
		SA_Parse(event, type, ...);	
	end
end

function SA_Parse(event, type, ...)

	if (not arg1) then
		return;
	end

	------
	-- Begin processing chat events
	------
	
	if (type == "SPELL_AURA_APPLIED" ) then
		local _,spellName,_ = select(9, ...)
		if( spellName == SA_SLAM ) then
			SA_Alert();
		end
	end
end

function SA_Alert()
	if ( SA.on == 1 ) then
		if (SA.soundon == 1) then
			PlaySoundFile("Interface\\AddOns\\SlamAlert\\Sounds\\SA.wav");
		end
		if (SA.messageon == 1) then
			SAlertMessageFrame:AddMessage("SLAM!", 1, 1, 1, 1, 1);
		end
	end
end

function SA_OnOff()
	if ( SA.on == 0 ) then
		SA.on = 1;
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SA_STON);
	else
		SA.on = 0;
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SA_STOFF);
	end
end

function SA_SoundOnOff()
	if ( SA.soundon == 0 ) then
		SA.soundon = 1;
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SOUND_STON);
	else
		SA.soundon = 0;
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SOUND_STOFF);
	end
end

function SA_MessageOnOff()
	if ( SA.messageon == 0 ) then
		SA.messageon = 1;
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_MESSAGE_STON);
	else
		SA.messageon = 0;
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_MESSAGE_STOFF);
	end
end

function SA_Status()
	if ( SA.on == 1 ) then
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SA_STON);
	else
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SA_STOFF);
	end
	if ( SA.messageon == 1 ) then
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_MESSAGE_STON);
	else
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_MESSAGE_STOFF);
	end
	if ( SA.soundon == 1 ) then
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SOUND_STON);
	else
		DEFAULT_CHAT_FRAME:AddMessage(SA_TEXT_SOUND_STOFF);
	end
end
